Index: /branches/UKMO/ROMS_WAD_7832/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-XC_ARCHER_INTEL
===================================================================
--- /branches/UKMO/ROMS_WAD_7832/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-XC_ARCHER_INTEL	(revision 8840)
+++ /branches/UKMO/ROMS_WAD_7832/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-XC_ARCHER_INTEL	(revision 8841)
@@ -50,4 +50,5 @@
   export INPUT_DIR=DEF_INPUT_DIR
   export CONFIG_DIR=DEF_CONFIG_DIR
+  export TOOLS_DIR=DEF_TOOLS_DIR
   export NEMO_VALIDATION_DIR=DEF_NEMO_VALIDATION
   export NEW_CONF=DEF_NEW_CONF
Index: /branches/UKMO/ROMS_WAD_7832/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-ifort_athena
===================================================================
--- /branches/UKMO/ROMS_WAD_7832/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-ifort_athena	(revision 8840)
+++ /branches/UKMO/ROMS_WAD_7832/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-ifort_athena	(revision 8841)
@@ -43,4 +43,5 @@
   export INPUT_DIR=DEF_INPUT_DIR
   export CONFIG_DIR=DEF_CONFIG_DIR
+  export TOOLS_DIR=DEF_TOOLS_DIR
   export NEMO_VALIDATION_DIR=DEF_NEMO_VALIDATION
   export NEW_CONF=DEF_NEW_CONF
Index: /branches/UKMO/ROMS_WAD_7832/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-ifort_athena_xios
===================================================================
--- /branches/UKMO/ROMS_WAD_7832/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-ifort_athena_xios	(revision 8840)
+++ /branches/UKMO/ROMS_WAD_7832/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-ifort_athena_xios	(revision 8841)
@@ -49,4 +49,5 @@
   export INPUT_DIR=DEF_INPUT_DIR
   export CONFIG_DIR=DEF_CONFIG_DIR
+  export TOOLS_DIR=DEF_TOOLS_DIR
   export NEMO_VALIDATION_DIR=DEF_NEMO_VALIDATION
   export NEW_CONF=DEF_NEW_CONF
Index: /branches/UKMO/ROMS_WAD_7832/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-macport_osx
===================================================================
--- /branches/UKMO/ROMS_WAD_7832/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-macport_osx	(revision 8840)
+++ /branches/UKMO/ROMS_WAD_7832/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-macport_osx	(revision 8841)
@@ -44,4 +44,5 @@
   export INPUT_DIR=DEF_INPUT_DIR
   export CONFIG_DIR=DEF_CONFIG_DIR
+  export TOOLS_DIR=DEF_TOOLS_DIR
   export NEMO_VALIDATION_DIR=DEF_NEMO_VALIDATION
   export NEW_CONF=DEF_NEW_CONF
Index: /branches/UKMO/ROMS_WAD_7832/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-macport_osx_debug
===================================================================
--- /branches/UKMO/ROMS_WAD_7832/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-macport_osx_debug	(revision 8840)
+++ /branches/UKMO/ROMS_WAD_7832/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-macport_osx_debug	(revision 8841)
@@ -44,4 +44,5 @@
   export INPUT_DIR=DEF_INPUT_DIR
   export CONFIG_DIR=DEF_CONFIG_DIR
+  export TOOLS_DIR=DEF_TOOLS_DIR
   export NEMO_VALIDATION_DIR=DEF_NEMO_VALIDATION
   export NEW_CONF=DEF_NEW_CONF
Index: /branches/UKMO/ROMS_WAD_7832/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-mpmd-ALTIX_NAUTILUS_MPT
===================================================================
--- /branches/UKMO/ROMS_WAD_7832/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-mpmd-ALTIX_NAUTILUS_MPT	(revision 8840)
+++ /branches/UKMO/ROMS_WAD_7832/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-mpmd-ALTIX_NAUTILUS_MPT	(revision 8841)
@@ -68,4 +68,5 @@
   export INPUT_DIR=DEF_INPUT_DIR
   export CONFIG_DIR=DEF_CONFIG_DIR
+  export TOOLS_DIR=DEF_TOOLS_DIR
   export NEMO_VALIDATION_DIR=DEF_NEMO_VALIDATION
   export NEW_CONF=DEF_NEW_CONF
Index: /branches/UKMO/ROMS_WAD_7832/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-openmpi_NAVITI_MERCATOR
===================================================================
--- /branches/UKMO/ROMS_WAD_7832/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-openmpi_NAVITI_MERCATOR	(revision 8840)
+++ /branches/UKMO/ROMS_WAD_7832/NEMOGCM/SETTE/BATCH_TEMPLATE/batch-openmpi_NAVITI_MERCATOR	(revision 8841)
@@ -40,4 +40,5 @@
   export INPUT_DIR=DEF_INPUT_DIR
   export CONFIG_DIR=DEF_CONFIG_DIR
+  export TOOLS_DIR=DEF_TOOLS_DIR
   export NEMO_VALIDATION_DIR=DEF_NEMO_VALIDATION
   export NEW_CONF=DEF_NEW_CONF
Index: /branches/UKMO/ROMS_WAD_7832/NEMOGCM/SETTE/BATCH_TEMPLATE/sette_batch_template
===================================================================
--- /branches/UKMO/ROMS_WAD_7832/NEMOGCM/SETTE/BATCH_TEMPLATE/sette_batch_template	(revision 8840)
+++ /branches/UKMO/ROMS_WAD_7832/NEMOGCM/SETTE/BATCH_TEMPLATE/sette_batch_template	(revision 8841)
@@ -44,4 +44,5 @@
   export INPUT_DIR=DEF_INPUT_DIR
   export CONFIG_DIR=DEF_CONFIG_DIR
+  export TOOLS_DIR=DEF_TOOLS_DIR
   export NEMO_VALIDATION_DIR=DEF_NEMO_VALIDATION
   export NEW_CONF=DEF_NEW_CONF
Index: /branches/UKMO/ROMS_WAD_7832/NEMOGCM/SETTE/all_functions.sh
===================================================================
--- /branches/UKMO/ROMS_WAD_7832/NEMOGCM/SETTE/all_functions.sh	(revision 8840)
+++ /branches/UKMO/ROMS_WAD_7832/NEMOGCM/SETTE/all_functions.sh	(revision 8841)
@@ -172,4 +172,5 @@
 echo "COMPILER is : ${CMP_NAM}"
 echo "TEST is : ${TEST_NAME}"
+echo "TOOLS directory is : ${TOOLS_DIR}"
 ################################################################
 # SMALL DEBUG
Index: /branches/UKMO/ROMS_WAD_7832/NEMOGCM/SETTE/prepare_job.sh
===================================================================
--- /branches/UKMO/ROMS_WAD_7832/NEMOGCM/SETTE/prepare_job.sh	(revision 8840)
+++ /branches/UKMO/ROMS_WAD_7832/NEMOGCM/SETTE/prepare_job.sh	(revision 8841)
@@ -151,24 +151,4 @@
 fi
 ################################################################
-
-##########################################################################
-# COPY RESTART FILES (if needed; i.e. only for SHORT job in RESTART TESTS)
-# get the input tarfile if needed
-# SF : not ok for the moment because at this point is needed cn_exp variable,
-# SF : here it it not known.
-#\cd ${EXE_DIR}
-#if [ "$(echo ${TEST_NAME} | grep -c "SHORT" )" -ne 0 ] ; then
-#    for (( i=1; i<=${NB_PROC}; ${NB_PROC}++)) ; do
-#        L_NPROC=`printf "%04d\n" $i`
-#        ln -sf ../LONG/${NEW_CONF}_00000060_restart_${L_NPROC-1}.nc .
-#    done
-#fi
-## SF : other way
-##      for file in ../LONG/${NEW_CONF}_*restart_0*.nc ; do
-##              ncpu=`echo $file | awk -F '_' '{print $NF}' | cut -f 1 -d '.'`
-##              ln -sf ${file}  .
-##      done
-##fi
-##########################################################################
 
 ################################################################
@@ -309,4 +289,5 @@
              -e"s:DEF_EXE_DIR:${EXE_DIR}:" \
              -e"s:DEF_CONFIG_DIR:${CONFIG_DIR}:" \
+             -e"s:DEF_TOOLS_DIR:${TOOLS_DIR}:" \
              -e"s:MPI_FLAG:${MPI_FLAG}:" \
              -e"s:DEF_NEMO_VALIDATION:${NEMO_VALIDATION_DIR}:" -e"s:DEF_NEW_CONF:${NEW_CONF}:" \
Index: /branches/UKMO/ROMS_WAD_7832/NEMOGCM/SETTE/sette.sh
===================================================================
--- /branches/UKMO/ROMS_WAD_7832/NEMOGCM/SETTE/sette.sh	(revision 8840)
+++ /branches/UKMO/ROMS_WAD_7832/NEMOGCM/SETTE/sette.sh	(revision 8841)
@@ -144,5 +144,4 @@
 
 for config in 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16
-
 do
 
@@ -661,5 +660,5 @@
     export TEST_NAME="LONG"
     cd ${CONFIG_DIR0}
-    . ./makenemo -m ${CMP_NAM} -n AMM12_LONG -r AMM12 -j 8 add_key "key_tide" del_key ${DEL_KEYS}
+    . ./makenemo -m ${CMP_NAM} -n AMM12_LONG -r AMM12 -j 8 del_key ${DEL_KEYS}
     cd ${SETTE_DIR}
     . ./param.cfg
@@ -800,6 +799,6 @@
     set_namelist namelist_cfg cn_exp \"SAS\"
     set_namelist namelist_cfg nn_it000 1
-    set_namelist namelist_cfg nn_itend 100
-    set_namelist namelist_cfg nn_stock 50
+    set_namelist namelist_cfg nn_itend 240
+    set_namelist namelist_cfg nn_stock 120
     set_namelist namelist_cfg ln_ctl .false.
     set_namelist namelist_cfg ln_clobber .true.
@@ -823,6 +822,6 @@
     cd ${EXE_DIR}
     set_namelist namelist_cfg cn_exp \"SAS\"
-    set_namelist namelist_cfg nn_it000 51
-    set_namelist namelist_cfg nn_itend 100
+    set_namelist namelist_cfg nn_it000 121
+    set_namelist namelist_cfg nn_itend 240
     set_namelist namelist_cfg ln_ctl .false.
     set_namelist namelist_cfg ln_clobber .true.
@@ -835,5 +834,7 @@
     set_namelist namelist_cfg ln_rstart .true.
     set_namelist namelist_cfg nn_rstctl 2
-    set_namelist namelist_ice_cfg cn_icerst_in \"SAS_00000050_restart_ice\"
+    set_namelist namelist_cfg nn_date0 010106
+    set_namelist namelist_cfg cn_ocerst_in \"SAS_00000120_restart\"
+    set_namelist namelist_ice_cfg cn_icerst_in \"SAS_00000120_restart_ice\"
     if [ ${USING_MPMD} == "yes" ] ; then
        set_xio_using_server iodef.xml true
@@ -844,5 +845,6 @@
         L_NPROC=$(( $i - 1 ))
         L_NPROC=`printf "%04d\n" ${L_NPROC}`
-        ln -sf ../LONG/SAS_00000050_restart_ice_${L_NPROC}.nc .
+        ln -sf ../LONG/SAS_00000120_restart_${L_NPROC}.nc .
+        ln -sf ../LONG/SAS_00000120_restart_ice_${L_NPROC}.nc .
     done
     cd ${SETTE_DIR}
@@ -1219,5 +1221,5 @@
     export TEST_NAME="LONG"
     cd ${CONFIG_DIR0}
-    . ./makenemo -m ${CMP_NAM} -n ORCA2AGUL_LONG -r ORCA2_LIM3_PISCES -d "OPA_SRC LIM_SRC_3 NST_SRC" -j 8 add_key "key_agrif" del_key "key_zdftmx key_top"
+    . ./makenemo -m ${CMP_NAM} -n ORCA2AGUL_LONG -r ORCA2_LIM3_PISCES -d "OPA_SRC LIM_SRC_3 NST_SRC" -j 8 add_key "key_agrif key_zdftmx" del_key "key_zdftmx_new key_top"
     cd ${SETTE_DIR}
     . ./param.cfg
@@ -1245,4 +1247,5 @@
     set_namelist 1_namelist_cfg nn_itend 300
     set_namelist 1_namelist_cfg nn_stock 150
+    set_namelist 1_namelist_cfg nn_fsbc 1
     set_namelist 1_namelist_cfg ln_ctl .false.
     set_namelist 1_namelist_cfg ln_clobber .true.
@@ -1283,4 +1286,5 @@
     set_namelist 1_namelist_cfg nn_itend 300
     set_namelist 1_namelist_cfg nn_stock 150
+    set_namelist 1_namelist_cfg nn_fsbc 1
     set_namelist 1_namelist_cfg ln_rstart .true.
     set_namelist 1_namelist_cfg nn_rstctl 2
@@ -1293,4 +1297,5 @@
     set_namelist namelist_ice_cfg cn_icerst_in \"O2LP_LONG_00000075_restart_ice\"
     set_namelist 1_namelist_cfg cn_ocerst_in \"O2LP_LONG_00000150_restart\"
+    set_namelist 1_namelist_ice_cfg cn_icerst_in \"O2LP_LONG_00000150_restart_ice\"
 
     for (( i=1; i<=$NPROC; i++)) ; do
@@ -1300,4 +1305,5 @@
         ln -sf ../LONG/O2LP_LONG_00000075_restart_ice_${L_NPROC}.nc .
         ln -sf ../LONG/1_O2LP_LONG_00000150_restart_${L_NPROC}.nc .
+        ln -sf ../LONG/1_O2LP_LONG_00000150_restart_ice_${L_NPROC}.nc .
     done
     if [ ${USING_MPMD} == "yes" ] ; then
@@ -1316,5 +1322,5 @@
     export TEST_NAME="REPRO_4_4"
     cd ${CONFIG_DIR0}
-    . ./makenemo -m ${CMP_NAM} -n ORCA2AGUL_16 -r ORCA2_LIM3_PISCES -d "OPA_SRC LIM_SRC_3 NST_SRC" -j 8 add_key "key_agrif" del_key "key_zdftmx key_top"
+    . ./makenemo -m ${CMP_NAM} -n ORCA2AGUL_16 -r ORCA2_LIM3_PISCES -d "OPA_SRC LIM_SRC_3 NST_SRC" -j 8 add_key "key_agrif key_zdftmx" del_key "key_zdftmx_new key_top"
     cd ${SETTE_DIR}
     . ./param.cfg
@@ -1339,4 +1345,5 @@
     set_namelist 1_namelist_cfg nn_it000 1
     set_namelist 1_namelist_cfg nn_itend 150
+    set_namelist 1_namelist_cfg nn_fsbc 1
     set_namelist 1_namelist_cfg ln_ctl .false.
     set_namelist 1_namelist_cfg ln_clobber .true.
@@ -1377,4 +1384,5 @@
     set_namelist 1_namelist_cfg nn_it000 1
     set_namelist 1_namelist_cfg nn_itend 150
+    set_namelist 1_namelist_cfg nn_fsbc 1
     set_namelist 1_namelist_cfg ln_ctl .false.
     set_namelist 1_namelist_cfg ln_clobber .true.
Index: /branches/UKMO/ROMS_WAD_7832/NEMOGCM/SETTE/sette_rpt.sh
===================================================================
--- /branches/UKMO/ROMS_WAD_7832/NEMOGCM/SETTE/sette_rpt.sh	(revision 8840)
+++ /branches/UKMO/ROMS_WAD_7832/NEMOGCM/SETTE/sette_rpt.sh	(revision 8841)
@@ -1,3 +1,4 @@
 #!/bin/bash -f
+#set -vx
 #
 # simple SETTE report generator.
@@ -10,4 +11,71 @@
 ######################### Start of function definitions #################################
 ##
+
+function restfile() {
+# Rebuild ice restart for SAS CONFIG, and restartability checks. Expects LONG and SHORT run directories.
+# For Stand Alone Surface configuration ocean is not running, just run ice model; so no outputs ocean files.
+# Compares LONG rebuild restart ice file with equivalent entry from the SHORT rebuild restart ice file.
+#
+  vdir=$1
+  nam=$2
+  pass=$3
+#
+  if [ -d $vdir/$nam ]; then
+    dorv=`ls -1rt $vdir/$nam/$mach/ | tail -1l `
+    dorv=`echo $dorv | sed -e 's:.*/::'`
+    rep1=`ls -1rt $vdir/$nam/$mach/$dorv/ | tail -2l | head -1 `
+    rep2=`ls -1rt $vdir/$nam/$mach/$dorv/ | tail -1l`
+    cd ${SAS_RESTART_DIR}/LONG
+    #SF add here compilation of rebuild_tools to rebuild restart files, and add comparison of restart files
+    cd ${TOOLS_DIR}
+    ./maketools -n REBUILD_NEMO -m ${mach} > /dev/null 2>&1
+    cd ${TOOLS_DIR}/REBUILD_NEMO
+    #SF echo "REBUILD LONG restart SAS files, without standard output"
+    ./rebuild_nemo -t 4 ../../CONFIG/SAS_LONG/LONG/SAS_00000100_restart_ice  $NPROC > /dev/null 2>&1
+    #SF echo "REBUILD SHORT restart SAS files, without standard output"
+    ./rebuild_nemo -t 4 ../../CONFIG/SAS_LONG/SHORT/SAS_00000100_restart_ice $NPROC >&-
+    cd ${SAS_RESTART_DIR}/LONG
+    #SF echo "COPY rebuild restart files"
+    cp SAS_00000100_restart_ice.nc $vdir/$nam/$mach/$dorv/LONG/.
+    cp ../SHORT/SAS_00000100_restart_ice.nc $vdir/$nam/$mach/$dorv/SHORT/.
+
+    f1o=$vdir/$nam/$mach/$dorv/LONG/SAS_00000100_restart_ice.nc
+    f2o=$vdir/$nam/$mach/$dorv/SHORT/SAS_00000100_restart_ice.nc
+    if  [ ! -f $f1o ] &&  [ ! -f $f2o ] ; then
+      printf "%-20s %s\n" $nam " REBUILD SAS restart ice DOES NOT exists; incomplete test";
+      return;
+    fi
+    #
+    done_oce=0
+    #
+    if  [  -f $f1o ] && [  -f $f2o ]; then
+      cmp -s $f1o $f2o 
+      #SF  cmp SAS_00000100_restart_ice.nc  ../SHORT/SAS_00000100_restart_ice.nc  > diff_restart.txt
+      if [ $? == 0 ]; then
+        if [ $pass == 0 ]; then
+          printf "%-20s %s %s\n" $nam  " SAS restart files are IDENTICAL :  passed : " $dorv
+        fi
+      else
+        printf "%-20s %s %s\n" $nam  " SAS restart files are DIFFERENT : FAILED : " $dorv 
+        #
+	# Offer view of differences on the second pass
+	#
+        if [ $pass == 1 ]; then
+          echo "BE CAREFUL:  NEED cdo to see differences!!!!! "
+          echo "DO which cdo and replace cdo PATH to the cdo command in SETTE_rpt.sh "
+          echo "IF cdo is not available you need to do difference of netcdf file by hand"
+          echo "<return> to view restart_ice.nc differences"
+          read y
+          cdo -diffv $f1o $f2o
+          done_oce=1
+          #echo "<return> to continue"
+          #read y
+        fi
+      fi
+    fi
+#
+fi
+}
+
 function resttest() { 
 #
@@ -199,4 +267,13 @@
   mach=`grep "COMPILER=" ./sette.sh | sed -e 's/COMPILER=//'`
   NEMO_VALID=`grep "NEMO_VALIDATION_DIR=" ./param.cfg | sed -e 's/NEMO_VALIDATION_DIR=//'`
+# Directory to run the tests
+ SETTE_DIR=$(cd $(dirname "$0"); pwd)
+ MAIN_DIR=$(dirname $SETTE_DIR)
+ CONFIG_DIR0=${MAIN_DIR}/CONFIG
+ TOOLS_DIR=${MAIN_DIR}/TOOLS
+ COMPIL_DIR=${TOOLS_DIR}/COMPILE
+ NPROC=32
+
+  SAS_RESTART_DIR=${CONFIG_DIR0}/SAS_LONG
 #
   if [ ! -d $NEMO_VALID ]; then
@@ -205,4 +282,5 @@
   fi
 #
+
 # The script also needs the date or revision tag. Currently this is taken from the latest sub-directory found in each directory
 #  
@@ -212,7 +290,16 @@
  if [ $pass == 1 ]; then echo "---------------2nd pass------------------";fi
 #
+
+# Rebuild and restartability test for SAS
+#
+ for restart_file in WSAS_LONG
+ do
+ #  restfile $SAS_RESTART_DIR LONG $pass
+   restfile $NEMO_VALID $restart_file $pass
+ done
+#
 # Restartability test
 #
- for restart_test in WGYREPIS_LONG WORCA2LIM3PIS_LONG WORCA2OFFPIS_LONG WAMM12_LONG WSAS_LONG WISOMIP_LONG WORCA2AGUL_LONG
+ for restart_test in WGYREPIS_LONG WORCA2LIM3PIS_LONG WORCA2OFFPIS_LONG WAMM12_LONG WISOMIP_LONG WORCA2AGUL_LONG
  do
    resttest $NEMO_VALID $restart_test $pass
Index: /branches/UKMO/ROMS_WAD_7832/NEMOGCM/TOOLS/COMPILE/Fadd_keys.sh
===================================================================
--- /branches/UKMO/ROMS_WAD_7832/NEMOGCM/TOOLS/COMPILE/Fadd_keys.sh	(revision 8840)
+++ /branches/UKMO/ROMS_WAD_7832/NEMOGCM/TOOLS/COMPILE/Fadd_keys.sh	(revision 8841)
@@ -65,5 +65,5 @@
  echo "Adding keys in : ${NEW_CONF}" 
  for i in ${list_add_key} ; do
-	if [ "$(cat ${CONFIG_DIR}/${NEW_CONF}/cpp_${NEW_CONF}.fcm | grep -c "$i" )" -ne 0 ] ; then
+	if [ "$(cat ${CONFIG_DIR}/${NEW_CONF}/cpp_${NEW_CONF}.fcm | grep -c "\<$i\>" )" -ne 0 ] ; then
  	   echo "key $i already present in cpp_${NEW_CONF}.fcm" 
 	else
Index: /branches/UKMO/ROMS_WAD_7832/NEMOGCM/TOOLS/COMPILE/Fdel_keys.sh
===================================================================
--- /branches/UKMO/ROMS_WAD_7832/NEMOGCM/TOOLS/COMPILE/Fdel_keys.sh	(revision 8840)
+++ /branches/UKMO/ROMS_WAD_7832/NEMOGCM/TOOLS/COMPILE/Fdel_keys.sh	(revision 8841)
@@ -60,16 +60,22 @@
 #
 #-
- echo "Removing keys in : ${NEW_CONF}"
- for i in ${list_del_key} ; do
-        if [ "$(echo ${i} | grep -c key_nproc )" -ne 0 ] ; then
-	        sed -e "s/key_nproc[ij]=.* //"  ${CONFIG_DIR}/${NEW_CONF}/cpp_${NEW_CONF}.fcm >  ${CONFIG_DIR}/${NEW_CONF}/cpp_${NEW_CONF}.fcm.tmp
-                mv ${CONFIG_DIR}/${NEW_CONF}/cpp_${NEW_CONF}.fcm.tmp   ${CONFIG_DIR}/${NEW_CONF}/cpp_${NEW_CONF}.fcm
-                echo " "
-        elif [ "$(cat ${CONFIG_DIR}/${NEW_CONF}/cpp_${NEW_CONF}.fcm | grep -c "$i" )" -ne 0 ] ; then
-        	sed -e "s/${i}//"  ${CONFIG_DIR}/${NEW_CONF}/cpp_${NEW_CONF}.fcm >  ${CONFIG_DIR}/${NEW_CONF}/cpp_${NEW_CONF}.fcm.tmp
-        	mv ${CONFIG_DIR}/${NEW_CONF}/cpp_${NEW_CONF}.fcm.tmp   ${CONFIG_DIR}/${NEW_CONF}/cpp_${NEW_CONF}.fcm
-        	echo "deleted key $i in ${NEW_CONF}"
-        fi
- done
 
- unset -v list_del_key
+echo "Removing keys in : ${NEW_CONF}"
+
+for i in ${list_del_key} ; do
+
+     if [ "$(echo ${i} | grep -c key_nproc )" -ne 0                                      ]; then
+        sed -e "s/key_nproc[ij]=.* //" ${CONFIG_DIR}/${NEW_CONF}/cpp_${NEW_CONF}.fcm \
+	    >  ${CONFIG_DIR}/${NEW_CONF}/cpp_${NEW_CONF}.fcm.tmp
+        mv ${CONFIG_DIR}/${NEW_CONF}/cpp_${NEW_CONF}.fcm.tmp ${CONFIG_DIR}/${NEW_CONF}/cpp_${NEW_CONF}.fcm
+        echo " "
+     elif [ "$(cat ${CONFIG_DIR}/${NEW_CONF}/cpp_${NEW_CONF}.fcm | grep -c "$i" )" -ne 0 ]; then
+         sed -e "s/\b${i}\b//" ${CONFIG_DIR}/${NEW_CONF}/cpp_${NEW_CONF}.fcm \
+	     >  ${CONFIG_DIR}/${NEW_CONF}/cpp_${NEW_CONF}.fcm.tmp
+         mv ${CONFIG_DIR}/${NEW_CONF}/cpp_${NEW_CONF}.fcm.tmp ${CONFIG_DIR}/${NEW_CONF}/cpp_${NEW_CONF}.fcm
+         echo "deleted key $i in ${NEW_CONF}"
+     fi
+
+done
+
+unset -v list_del_key
Index: /branches/UKMO/ROMS_WAD_7832/NEMOGCM/TOOLS/COMPILE/Fmake_WORK.sh
===================================================================
--- /branches/UKMO/ROMS_WAD_7832/NEMOGCM/TOOLS/COMPILE/Fmake_WORK.sh	(revision 8840)
+++ /branches/UKMO/ROMS_WAD_7832/NEMOGCM/TOOLS/COMPILE/Fmake_WORK.sh	(revision 8841)
@@ -105,5 +105,5 @@
 done
 
-for i in `(cd ${ZCONF}/MY_SRC ; ls *.[Ffh]90 2>/dev/null ) `
+for i in `(cd ${ZCONF}/MY_SRC ; \ls *.[Ffh]90 2>/dev/null ) `
    do
       [ -f ${ZCONF}/MY_SRC/$i ] &&  ln -sf $PWD/${ZCONF}/MY_SRC/${i} ${ZCONF}/WORK/.
Index: /branches/UKMO/ROMS_WAD_7832/NEMOGCM/TOOLS/DOMAINcfg/src/domzgr.f90
===================================================================
--- /branches/UKMO/ROMS_WAD_7832/NEMOGCM/TOOLS/DOMAINcfg/src/domzgr.f90	(revision 8840)
+++ /branches/UKMO/ROMS_WAD_7832/NEMOGCM/TOOLS/DOMAINcfg/src/domzgr.f90	(revision 8841)
@@ -2078,4 +2078,6 @@
       hbatt(:,:) = zenv(:,:) 
       IF( MINVAL( gphit(:,:) ) * MAXVAL( gphit(:,:) ) <= 0._wp ) THEN
+          IF ( jphgr_msh == 2 .OR. jphgr_msh == 3) CALL ctl_stop( 'dom:zgr_sco:  if jphgr_msh = 2 or 3 and  & 
+                                      & s-coordinates stop, if not correction at Equator is applied, but it is wrong')
          CALL ctl_warn( ' s-coordinates are tapered in vicinity of the Equator' )
          DO jj = 1, jpj
Index: /branches/UKMO/ROMS_WAD_7832/NEMOGCM/TOOLS/MISCELLANEOUS/chk_iomput.sh
===================================================================
--- /branches/UKMO/ROMS_WAD_7832/NEMOGCM/TOOLS/MISCELLANEOUS/chk_iomput.sh	(revision 8840)
+++ /branches/UKMO/ROMS_WAD_7832/NEMOGCM/TOOLS/MISCELLANEOUS/chk_iomput.sh	(revision 8841)
@@ -37,5 +37,5 @@
 	    echo '      ./chk_iomput.sh'
 	    echo '      ./chk_iomput.sh --help'
-	    echo '      ./chk_iomput.sh ../../CONFIG/ORCA2_LIM/EXP00/iodef.xml "../../NEMO/OPA_SRC/ ../../NEMO/LIM_SRC_2/"'
+	    echo '      ./chk_iomput.sh ../../CONFIG/ORCA2_LIM/EXP00/context_nemo.xml "../../NEMO/OPA_SRC/ ../../NEMO/LIM_SRC_2/"'
 	    echo
 	    exit ;;
@@ -51,5 +51,11 @@
 done 
 #
-[ ! -f "$xmlfile" ] && echo "$xmlfile not found, we stop..." && exit
+echo $xmlfile
+echo $srcdir
+
+for i in $xmlfile
+do
+    [ ! -f "$xmlfile" ] && echo "$xmlfile not found, we stop..." && exit
+done
 for i in $srcdir 
 do
@@ -60,11 +66,26 @@
 #
 external=$( grep -c "<field_definition  *\([^ ].* \)*src=" $xmlfile )
-if [ $external -eq 1 ]
+if [ $external -ge 1 ]
 then
     xmlfield_def=$( grep "<field_definition  *\([^ ].* \)*src=" $xmlfile | sed -e 's/.*src="\([^"]*\)".*/\1/' )
-    xmlfield_def=$( dirname $xmlfile )/$xmlfield_def   
+    tmp_def=""
+    for fdef in $xmlfield_def ; do tmp_def="$tmp_def $( dirname $xmlfile )/$fdef" ; done
+    xmlfield_def=$tmp_def
+    echo $xmlfield_def
 else
     xmlfield_def=$xmlfile
 fi
+external=$( grep -c "<file_definition  *\([^ ].* \)*src=" $xmlfile )
+if [ $external -ge 1 ]
+then
+    xmlfile_def=$( grep "<file_definition  *\([^ ].* \)*src=" $xmlfile | sed -e 's/.*src="\([^"]*\)".*/\1/' )
+    tmp_def=""
+    for fdef in $xmlfile_def ; do tmp_def="$tmp_def $( dirname $xmlfile )/$fdef" ; done
+    xmlfile_def=$tmp_def
+    echo $xmlfile_def
+else
+    xmlfile_def=$xmlfile
+fi
+
 [ $inxml -eq 1 ] && grep "< *field  *\([^ ].* \)*id *=" $xmlfield_def
 [ $insrc -eq 1 ] && find $srcdir -name "*.[Ffh]90" -exec grep -iH "^[^\!]*call  *iom_put *(" {} \;
@@ -95,5 +116,5 @@
 # list of variables to be outputed in the xml file
 #
-varlistout=$( grep "< *field  *\([^ ].* \)*field_ref *=" $xmlfile  | sed -e "s/^.*< *field .*field_ref *= *[\"\']\([^\"\']*\)[\"\'].*/\1/" | sort -d )
+varlistout=$( grep "< *field  *\([^ ].* \)*field_ref *=" $xmlfile_def  | sed -e "s/^.*< *field .*field_ref *= *[\"\']\([^\"\']*\)[\"\'].*/\1/" | sort -d )
 #
 echo "--------------------------------------------------"
Index: /branches/UKMO/ROMS_WAD_7832/NEMOGCM/TOOLS/MISCELLANEOUS/icb_pp.py
===================================================================
--- /branches/UKMO/ROMS_WAD_7832/NEMOGCM/TOOLS/MISCELLANEOUS/icb_pp.py	(revision 8840)
+++ /branches/UKMO/ROMS_WAD_7832/NEMOGCM/TOOLS/MISCELLANEOUS/icb_pp.py	(revision 8841)
@@ -12,19 +12,26 @@
 # cases the missing instances are filled with invalid (NaN) values.
 #
+# Version 2.0 August 2017. Adapted to process all variables and retain original
+#                          datatypes. (acc@noc.ac.uk)
 
-parser = ArgumentParser(description='produce collated trajectory file from distributed output\
-                                     files, e.g. \n python ./icb_pp.py \
-                                     -t  trajectory_icebergs_004248_ -n 296 -o trajsout.nc' )
+parser = ArgumentParser(description='produce collated trajectory file \
+                                     from distributed output files, e.g. \
+                                     \n python ./icb_pp.py \
+                                     -t  trajectory_icebergs_004248_ \
+                                     -n 296 -o trajsout.nc' )
 
-parser.add_argument('-t',dest='froot',help='fileroot_of_distrbuted_data; root name of \
-                     distributed trajectory output (usually completed with XXXX.nc, where \
-                     XXXX is the 4 digit processor number)', 
-                     default='trajectory_icebergs_004248_')
+parser.add_argument('-t',dest='froot',
+                         help='fileroot_of_distrbuted_data; root name \
+                               of  distributed trajectory output (usually \
+                               completed with XXXX.nc, where  XXXX is the \
+                               4 digit processor number)', 
+                      default='trajectory_icebergs_004248_')
 
 parser.add_argument('-n',dest='fnum',help='number of distributed files to process', 
-                     type=int, default=None)
+                         type=int, default=None)
 
-parser.add_argument('-o',dest='fout',help='collated_output_file; file name to receive the \
-                     collated trajectory data', default='trajsout.nc')
+parser.add_argument('-o',dest='fout',
+                         help='collated_output_file; file name to receive \
+                              the collated trajectory data', default='trajsout.nc')
 
 args = parser.parse_args()
@@ -64,17 +71,22 @@
 #
 for n in range(procnum):
- nn = '%4.4d' % n
- fw = Dataset(pathstart+nn+'.nc')
- if len(fw.dimensions['n']) > 0:
-   print pathstart+nn+'.nc'
-   ic = fw.variables['iceberg_number'][:,0]
-   ts = fw.variables['timestep'][:]
-   icv = np.unique(ic)
-   ts = np.unique(ts)
-   print('Min Max ts: ',ts.min(), ts.max())
-   print('Number unique icebergs= ',icv.shape[0])
-   icu.append(icv)
-   times.append(ts)
- fw.close()
+    nn = '%4.4d' % n
+    fw = Dataset(pathstart+nn+'.nc')
+    # keep a list of the variables in the first dataset
+    if n == 0:
+        varlist = fw.variables
+    #
+    # skip any files with no icebergs
+    if len(fw.dimensions['n']) > 0:
+        print pathstart+nn+'.nc'
+        ic = fw.variables['iceberg_number'][:,0]
+        ts = fw.variables['timestep'][:]
+        icv = np.unique(ic)
+        ts = np.unique(ts)
+        print('Min Max ts: ',ts.min(), ts.max())
+        print('Number unique icebergs= ',icv.shape[0])
+        icu.append(icv)
+        times.append(ts)
+    fw.close()
 #
 # Now flatten the lists and reduce to the unique spanning set
@@ -89,71 +101,87 @@
 print('times range from:        ',times.min(), 'to: ', times.max())
 #
-# Declare 2-D arrays to receive the data from all files
+# Declare array to receive data from all files
 #
 nt = times.shape[0]
-lons = np.zeros((ntraj, nt))
-lats = np.zeros((ntraj, nt))
-tims = np.zeros((ntraj, nt))
-xis  = np.zeros((ntraj, nt))
-yjs  = np.zeros((ntraj, nt))
+#
+n=0
+for key, value in varlist.iteritems() :
+    if key != "iceberg_number" :
+        n = n + 1
+inarr = np.zeros((n, ntraj, nt))
 #
 # initially fill with invalid data
 #
-lons.fill(np.nan)
-lats.fill(np.nan)
-xis.fill(np.nan)
-yjs.fill(np.nan)
-tims.fill(np.nan)
+inarr.fill(np.nan)
+#
+# Declare some lists to store variable names, types and long_name and units attributes
+# iceberg_number gets special treatment
+innam = []
+intyp = []
+inlngnam = []
+inunits = []
+for key, value in varlist.iteritems() :
+    if key != "iceberg_number" :
+        innam.append(key)
+#
+# reopen the first datset to collect variable attributes
+# (long_name and units only)
+#
+nn = '%4.4d' % 0
+fw = Dataset(pathstart+nn+'.nc')
+for key, value in varlist.iteritems() :
+    if key != "iceberg_number" :
+        intyp.append(fw.variables[key].dtype)
+        inlngnam.append(fw.variables[key].getncattr('long_name'))
+        inunits.append(fw.variables[key].getncattr('units'))
+fw.close()
 #
 # loop through distributed datasets again, this time
 # checking indices against icu and times lists and
 # inserting data into the correct locations in the 
-# 2-D collated sets.
+# collated sets.
 #
 for n in range(procnum):
- nn = '%4.4d' % n
- fw = Dataset(pathstart+nn+'.nc')
+    nn = '%4.4d' % n
+    fw = Dataset(pathstart+nn+'.nc')
+#
 # Note many distributed datafiles will contain no iceberg data
 # so skip quickly over these
- m  = len(fw.dimensions['n'])
- if m > 0:
-   inx = np.zeros(m, dtype=int)
-   tsx = np.zeros(m, dtype=int)
-   print pathstart+nn+'.nc'
-   ic = fw.variables['iceberg_number'][:,0]
-   ts = fw.variables['timestep'][:]
-   lns = fw.variables['lon'][:]
-   lts = fw.variables['lat'][:]
-   xxs = fw.variables['xi'][:]
-   yys = fw.variables['yj'][:]
-   for k in range(m):
-     inxx   = np.where(icu == ic[k])
-     inx[k] = inxx[0]
-   for k in range(m):
-     inxx   = np.where(times == ts[k])
-     tsx[k] = inxx[0]
-   lons[inx[:],tsx[:]] = lns[:]
-   lats[inx[:],tsx[:]] = lts[:]
-   tims[inx[:],tsx[:]] = ts[:]
-   xis[inx[:],tsx[:]] = xxs[:]
-   yjs[inx[:],tsx[:]] = yys[:]
- fw.close()
-
+    m  = len(fw.dimensions['n'])
+    if m > 0:
+        inx = np.zeros(m, dtype=int)
+        tsx = np.zeros(m, dtype=int)
+        #print pathstart+nn+'.nc'
+        ic = fw.variables['iceberg_number'][:,0]
+        ts = fw.variables['timestep'][:]
+        for k in range(m):
+            inxx   = np.where(icu == ic[k])
+            inx[k] = inxx[0]
+        for k in range(m):
+            inxx   = np.where(times == ts[k])
+            tsx[k] = inxx[0]
+        n = 0
+        for key, value in varlist.iteritems() :
+            if key != "iceberg_number" :
+                insmall = fw.variables[innam[n]][:]
+                inarr[n,inx[:],tsx[:]] = insmall[:]
+                n = n + 1
+    fw.close()
+#
 # Finally create the output file and write out the collated sets
 #
-fo = Dataset(pathout, 'w', format='NETCDF4')
+fo = Dataset(pathout, 'w', format='NETCDF4_CLASSIC')
 ntrj = fo.createDimension('ntraj', ntraj)
 nti  = fo.createDimension('ntime', None)
-olon = fo.createVariable('lon', 'f4',('ntraj','ntime'))
-olat = fo.createVariable('lat', 'f4',('ntraj','ntime'))
-otim = fo.createVariable('ttim', 'f4',('ntraj','ntime'))
-oxis = fo.createVariable('xis', 'f4',('ntraj','ntime'))
-oyjs = fo.createVariable('yjs', 'f4',('ntraj','ntime'))
-icbn = fo.createVariable('icbn', 'f4',('ntraj'))
-olon[:,:] = lons
-olat[:,:] = lats
-otim[:,:] = tims
-oxis[:,:] = xis
-oyjs[:,:] = yjs
+icbn = fo.createVariable('iceberg_number', 'i4',('ntraj'))
 icbn[:] = icu
+n = 0
+for key, value in varlist.iteritems() :
+    if key != "iceberg_number" :
+        oout = fo.createVariable(innam[n], intyp[n], ('ntraj','ntime'),
+                                 zlib=True, complevel=1, chunksizes=(1,nt))
+        oout[:,:] = inarr[n,:,:]
+        oout.long_name = inlngnam[n]
+        oout.units = inunits[n]
+        n = n + 1
 fo.close()
Index: /branches/UKMO/ROMS_WAD_7832/NEMOGCM/TOOLS/NESTING/src/agrif_create_bathy.f90
===================================================================
--- /branches/UKMO/ROMS_WAD_7832/NEMOGCM/TOOLS/NESTING/src/agrif_create_bathy.f90	(revision 8840)
+++ /branches/UKMO/ROMS_WAD_7832/NEMOGCM/TOOLS/NESTING/src/agrif_create_bathy.f90	(revision 8841)
@@ -54,5 +54,5 @@
   REAL*8, DIMENSION(:,:),POINTER :: save_gdepw,rx,ry,maskedtopo
   REAL*8  :: Cell_lonmin,Cell_lonmax,Cell_latmin,Cell_latmax,wghts
-  LOGICAL :: Pacifique
+  LOGICAL :: Pacifique=.FALSE.
   INTEGER :: boundary,xpos,ypos,iimin,iimax,jjmax,jjmin
   INTEGER :: nbloops,nxhr,nyhr,ji,jj,nbiter,nbloopmax
Index: /branches/UKMO/ROMS_WAD_7832/NEMOGCM/TOOLS/NESTING/src/agrif_readwrite.f90
===================================================================
--- /branches/UKMO/ROMS_WAD_7832/NEMOGCM/TOOLS/NESTING/src/agrif_readwrite.f90	(revision 8840)
+++ /branches/UKMO/ROMS_WAD_7832/NEMOGCM/TOOLS/NESTING/src/agrif_readwrite.f90	(revision 8841)
@@ -232,5 +232,5 @@
     CHARACTER(len=1),DIMENSION(2) :: dimnames
     !
-    status = nf90_create(name,NF90_WRITE,ncid)
+    status = nf90_create(name,NF90_NOCLOBBER,ncid)
     status = nf90_close(ncid)          
     !
